searchNodes=[{"ref":"AssetImport.html","title":"AssetImport","type":"module","doc":""},{"ref":"readme.html","title":"AssetImport","type":"extras","doc":"AssetImport Webpack asset imports directly in Elixir code. For example in Phoenix controllers/views/templates or LiveView&#39;s."},{"ref":"readme.html#features","title":"AssetImport - Features","type":"extras","doc":"Only load assets that are used for current render. Helps to avoid assets over, under, or double fetching. Optimal asset packaging and cache reuse with Webpack code splitting. Supports Phoenix LiveView&#39;s by loading assets dynamically. Supports mix dependencies that are using asset_import."},{"ref":"readme.html#installation","title":"AssetImport - Installation","type":"extras","doc":"The package can be installed by adding asset_import to your list of dependencies in mix.exs: def deps do [ {:asset_import, &quot;~&gt; 0.3.1&quot;} ] end"},{"ref":"readme.html#usage","title":"AssetImport - Usage","type":"extras","doc":"/* assets/css/forms.css */ form { /* a lot of form styling, or import bootstrap `_forms.scss` etc */ } // assets/js/login_form.js import &quot;../css/forms.css&quot; // some login form specific javascript here Anywhere in your views, templates, or LiveView renders: &lt;div&gt; &lt;%= if @logged_in do %&gt; &lt;div&gt;My profile..&lt;/div&gt; &lt;% else %&gt; &lt;!-- You can use &lt;% asset_import &quot;js/login_form&quot; %&gt; (without =), if you are not using this template in LiveView. It will save some bytes from your html. --&gt; &lt;%= asset_import &quot;js/login_form&quot; %&gt; &lt;form&gt;Login form..&lt;/form&gt; &lt;% end %&gt; &lt;/div&gt; Assets js/login_form.js and css/forms.css are only loaded when user is not logged in."},{"ref":"readme.html#setup","title":"AssetImport - Setup","type":"extras","doc":"1. Configuration Typical asset_import config: # config/config.exs config :asset_import, MyAppWeb.Assets, assets_base_url: &quot;/&quot;, assets_path: Path.expand(&quot;assets&quot;), manifest_path: Path.expand(&quot;priv/static/manifest.json&quot;), entrypoints_path: Path.expand(&quot;assets/entrypoints.json&quot;) Replace phoenix watcher from webpack to nodemon: # config/dev.exs config :my_app, MyAppWeb.Endpoint, debug_errors: true, code_reloader: true, check_origin: false, watchers: [node: [&quot;node_modules/nodemon/bin/nodemon.js&quot;, cd: Path.expand(&quot;../assets&quot;, __DIR__)]] Disable entrypoints file generation in test. # config/test.exs config :asset_import, entrypoints_path: :disabled 2. Create an assets module defmodule MyAppWeb.Assets do use AssetImport, assets_path: &quot;assets&quot; # optional, defaults to &quot;assets&quot; end 3. Use your assets module in web module defmodule MyAppWeb do .. def view do quote do .. use MyAppWeb.Assets .. end end .. end 4. Add scripts and styles to layout &lt;!-- Content rendering has to execute before scripts and styles --&gt; &lt;% body = render &quot;body.html&quot;, assigns %&gt; &lt;html&gt; &lt;head&gt; &lt;!-- Styles for current page (render blocking) --&gt; &lt;%= asset_styles() %&gt; &lt;!-- Optional: Preload unused styles and scripts --&gt; &lt;%= preload_asset_styles() %&gt; &lt;%= preload_asset_scripts() %&gt; &lt;/head&gt; &lt;body&gt; &lt;%= body %&gt; &lt;!-- Scripts for current page --&gt; &lt;%= asset_scripts() %&gt; &lt;/body&gt; &lt;/html&gt; Or &lt;!-- Content rendering has to execute before scripts and styles --&gt; &lt;% body = render &quot;body.html&quot;, assigns %&gt; &lt;html&gt; &lt;head&gt; &lt;!-- Styles for current page (render blocking) --&gt; &lt;%= for path &lt;- asset_style_files() do %&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;&lt;%= path %&gt;&quot; /&gt; &lt;% end %&gt; &lt;!-- Optional: Preload unused styles and scripts --&gt; &lt;%= for path &lt;- unused_asset_style_files() do %&gt; &lt;link rel=&quot;preload&quot; href=&quot;&lt;%= path %&gt;&quot; as=&quot;style&quot;&gt; &lt;% end %&gt; &lt;%= for path &lt;- unused_asset_script_files() do %&gt; &lt;link rel=&quot;preload&quot; href=&quot;&lt;%= path %&gt;&quot; as=&quot;script&quot;&gt; &lt;% end %&gt; &lt;/head&gt; &lt;body&gt; &lt;%= body %&gt; &lt;!-- Scripts for current page --&gt; &lt;%= for path &lt;- asset_script_files() do %&gt; &lt;script type=&quot;text/javascript&quot; src=&quot;&lt;%= path %&gt;&quot;&gt;&lt;/script&gt; &lt;% end %&gt; &lt;/body&gt; &lt;/html&gt; 5. Add LiveView hook (only when LiveView is used) import LiveSocket from &quot;phoenix_live_view&quot; import Socket from &quot;phoenix&quot; import AssetImport from &quot;asset_import_hook&quot; let liveSocket = new LiveSocket(&quot;/live&quot;, Socket, { AssetImport }) liveSocket.connect() 6. Webpack setup Copy example_assets/* to your project assets or adjust existing files manually: // assets/nodemon.json { &quot;watch&quot;: [&quot;entrypoints.json&quot;, &quot;webpack.config.js&quot;], &quot;exec&quot;: &quot;node_modules/webpack/bin/webpack.js --color --mode development --watch-stdin&quot; } // assets/package.json { .. &quot;dependencies&quot;: { .. &quot;asset_import_hook&quot;: &quot;0.3.1&quot; // only when LiveView is used .. }, &quot;devDependencies&quot;: { .. &quot;nodemon&quot;: &quot;1.19.2&quot;, &quot;uglifyjs-webpack-plugin&quot;: &quot;2.2.0&quot;, .. } } // assets/webpack.config.js .. 8: const entrypoints = require(&#39;./entrypoints.json&#39;) || {}; 9: 10: if (Object.keys(entrypoints).length === 0) { 11: console.log(&#39;No entrypoints&#39;); 12: process.exit(); 13: return; 14: } .. 23: runtimeChunk: &#39;single&#39;, 24: chunkIds: &#39;natural&#39;, 25: concatenateModules: true, 26: splitChunks: { 27: chunks: &#39;all&#39;, 28: minChunks: 1, 29: minSize: 0 30: } 31: }, 32: entry: entrypoints, 33: output: { 34: filename: &#39;js/[id]-[contenthash].js&#39;, 35: chunkFilename: &#39;js/[id]-[contenthash].js&#39;, 36: path: path.resolve(__dirname, &#39;../priv/static&#39;) 37: }, 38: plugins: [ 39: new MiniCssExtractPlugin({ 40: filename: &#39;css/[id]-[contenthash].css&#39;, 41: chunkFilename: &#39;css/[id]-[contenthash].css&#39;, 42: }), 43: new ManifestPlugin({ fileName: &#39;manifest.json&#39; }), .."}]